#############################
# 10.1 Δrf[^̕
#############################

Scompare<-data.frame(
  ejX=c(NA, 11, 10, 5),
  싅=c(39, NA, 21,16),
  oXPbg{[=c(40, 29, NA, 21),
  TbJ[=c(45, 34, 29, NA),
  row.names=c("ejX","싅","oXPbg{[","TbJ[")
)
Sdata<-Scompare/50
diag(Sdata)<-0.5
Sdata


library(psych)
res<-thurstone(Sdata)
score<-res$scale
plot(score,rep(0, length(score)),pch=1, xaxt="n", yaxt="n", ylim=c(0,0.5), ylab="", bty="n",xpd=TRUE)
text(score, 0, names(score), pos=3)
axis(1,pos=0)


###################
# 10.3 v@
###################
set.seed(123)
library(conjoint)
ex<-expand.grid(a=c("a1","a2","a3"),
				b=c("b1","b2","b3"),
				c=c("c1","c2","c3"),
				d=c("d1","d2","d3"),
				e=c("e1","e2","e3")
)
exdesign<-caFactorialDesign(data=ex, type="orthogonal")
exdesign
dim(ex)
dim(exdesign)
exprof<-caEncodedDesign(exdesign)
exprof


###################################################
# 10.4 D܂vf𗝉iRWCǵj
###################################################

# vt@C̍쐬
library(conjoint)
set.seed(123)

TBattr<-list(StorageSize=c("e32GB","e16GB"),
	BatteryLife=c("12","8"),
	Weight=c("350g","450g"))

experiment<-expand.grid(TBattr)


# zɂṽfUC
TBdesign<-caFactorialDesign(data=experiment, type="orthogonal")
TBdesign

# vt@C̃R[h
TBprof<-caEncodedDesign(TBdesign)
TBprof


# lʂ̑ID(1~4)
TBorder<-as.data.frame(matrix(0,12,4))
TBorder[1,] <-c(1,4,3,2)
TBorder[2,] <-c(1,2,3,4)
TBorder[3,] <-c(1,2,4,3)
TBorder[4,] <-c(1,2,4,3)
TBorder[5,] <-c(1,4,2,3)
TBorder[6,] <-c(1,2,4,3)
TBorder[7,] <-c(1,3,4,2)
TBorder[8,] <-c(1,4,2,3)
TBorder[9,] <-c(1,4,3,2)
TBorder[10,]<-c(1,3,4,2)
TBorder[11,]<-c(2,4,1,3)
TBorder[12,]<-c(1,4,2,3)

# ID]ɕϊ
TBval<-5-TBorder

# x̖
TBlevn<-factor(c("e32GB","e16GB","12","8","350g","450g"))

# RWCg͂̎s
Conjoint(TBval,TBprof,TBlevn)

# IV~[V
TBsim<-as.data.frame(matrix(0,4,3))
TBsim[1,]<-c(1,1,1)
TBsim[2,]<-c(2,2,2)
TBsim[3,]<-c(1,2,1)
TBsim[4,]<-c(1,1,2)
names(TBsim)<-names(TBprof)

simname<-c("e32GB   8  350g",
	  "e16GB  12  450g",
	  "e32GB  12  350g",
	  "e32GB  8   450g")

simutil<-caLogit(TBsim,TBval,TBprof)
print(simutil)
pie(simutil,labels=simname ,clockwise=TRUE)

ShowAllSimulations(TBsim,TBval,TBprof)


###############################################################
# 10.5 D݂Ƌ𓯎ɗiWCgEXy[XE}bv
###############################################################

# q͂ɂuhE|WVjO}bv
Dataset<-read.csv("factor_data.csv",header=TRUE)
dim(Dataset)
Fdata<-Dataset[,3:13]
Brand<-Dataset[,2]
Bname<-levels(Brand)
pref<-8-Dataset[,14]

library(psych)
library(GPArotation)
library(maptools)

res<-fa(Fdata, nfactors=2,fm="ml",rotate="varimax",scores="Bartlett") 
FS<-res$scores

# uhʈq_̕ϒľvZ
meanFS<-aggregate(x=FS,by=list(Brand),FUN=mean)
k<-round(max(abs(meanFS[,2:3])),digit=1)+0.2

# uhʕψq_̃vbg
par(pty="s")
plot(meanFS$ML1,meanFS$ML2,pch=20,col="red",xlab="Factor1",ylab="Factor2",xlim=c(-k,k), ylim=c(-k,k))
abline(0,0,0,0)
pointLabel(x=meanFS$ML1,y=meanFS$ML2,labels=Bname)

# IDA
res2<-lm(pref~FS)
PR<-res2$coeff[2:3]  #W̑2,3vf
PR<-PR/sqrt(sum(PR^2)) #xNg̒1Ɋ
arrows(0,0,PR[1],PR[2]) #IDxNg`

