#####################################
# 11.1 KwI@ɂNX^[
#####################################

data<-read.csv("drink.csv")
drink<-data[,-1]
rownames(drink)<-data[,1]
colnames(drink)

# KwINX^[͂̎s
sdrink<-scale(drink)
sdrink.d<-dist(sdrink)
sdrink.hc<-hclust(sdrink.d,method="ward.D")
summary(sdrink.hc)
plot(sdrink.hc, cex=0.7, hang=-1, sub="",xlab="")

# c[4O[vɂȂ悤ɃJbg
smemb4 <- cutree(sdrink.hc, k = 4)

# eO[v̓ss
for(i in 1:4){
	print(smemb4[smemb4==i])
}

# O[vʂ̕ϒl̎Zo
s4gmean<-aggregate(sdrink, list(group=smemb4), mean)

kmax<-max(s4gmean[,-1])
kmin<-min(s4gmean[,-1])
s4gmean


# O[vʂ̕ϒl̃vbg(ʕ+_Otj
opar<-par(no.readonly = TRUE) 
layout(matrix(c(1,2,3,4),2,2,byrow=TRUE))
par(mex=1.5)
for(i in 1:4){
   barplot(as.matrix(s4gmean[i,-1]),,ylim=c(kmin,kmax),las=2,main=paste("Group",i,sep=""))
}
par(opar)


###################################
# 11.2 kmeans@ɂNX^[
###################################

# kmeans@ɂNX^[
set.seed(123)
drink.km<-kmeans(sdrink,4)
for(i in 1:4){
	print(drink.km$cluster[drink.km$cluster==i])
}


# O[vʂ̕ϒl̃vbg(ʕ+_Otj
kgmean<-drink.km$centers

kmax<-max(kgmean)
kmin<-min(kgmean)

opar<-par(no.readonly = TRUE) 
layout(matrix(c(1,2,3,4),2,2,byrow=TRUE))
par(mex=1.5)
for(i in 1:4){
   barplot(kgmean[i,],ylim=c(kmin,kmax),las=2,main=paste("Group",i,sep=""))
}
par(opar)


##########################################################
# 11.3 f[^𗘗puh̕ށiNX^[́j
##########################################################
library(bayesm)

# s̍쐬
data(Scotch)
Sdata<-as.matrix(Scotch)
head(Sdata)
SBS<-crossprod(Sdata)

# JC拗̌vZ
library(analogue)
d<-distance(SBS,method="chi.distance")

# KwINX^[
res<-hclust(as.dist(d), method="ward.D")
plot(res,sub="",xlab="")

# MDSɂ镪
library(MASS)
S.nmmds<-isoMDS(d)
k<-floor(max(abs(S.nmmds$points)))+1
op<-par(pty="s")

library(maptools)
plot(S.nmmds$points,pch=20,col="red",xlim=c(-k,k),ylim=c(-k,k),xlab="Dim1",ylab="Dim2")
pointLabel(S.nmmds$points,labels=rownames(S.nmmds$points))


###########################
# 11.4 ؂𗘗p
###########################
library(mvpart)
library(bayesm)
data(margarine)
hhid<-margarine$choicePrice$hhid
Gen<-(margarine$choicePrice$choice==5)
sumGen<-aggregate(x=Gen,by=list(hhid),FUN=sum)

demos<-margarine$demos
nhhid<-nrow(demos)
hhGen<-rep(0,nhhid)
hhGen[sumGen$x>=2]<-1

Gdata<-data.frame(hhGen,demos)

z <- rpart(hhGen~Income+Fam_Size+college+whtcollar+retired,data=Gdata)
summary(z)
plot(z); text(z,digits=3)


#################################
# 11.5 ݃NXfɂ镪
#################################

library(e1071)
D<-as.matrix(read.csv(file="lcadata.csv",header=TRUE))

# ݃NXfɂ镪
set.seed(123);SdLC1<-lca(D,1)
set.seed(123);SdLC2<-lca(D,2)
set.seed(123);SdLC3<-lca(D,3)
set.seed(123);SdLC4<-lca(D,4)

#BICɂ郂fI
c(SdLC1$bic,SdLC2$bic,SdLC3$bic,SdLC4$bic)

#NX2̏ꍇ̌ʂ̕\
print(SdLC2)

sp<-SdLC2$p
colnames(sp)<-colnames(D)
sp

opar=par(no.readonly = TRUE) 
# O[vʂ̕ϒl̃vbg(ʕ+_Otj
layout(matrix(c(1,2),1,2,byrow=TRUE))
for(i in 1:2){
   barplot(sp[i,],ylim=c(0,1),las=2,main=paste("Group",i,sep=""))
}
par(opar)

# V~[VEf[^̔
set.seed(999)
G1 <- c(0.8, 0.8, 0.2, 0.2, 0.8)
G2 <- c(0.2, 0.2, 0.8, 0.8, 0.2)
x <- matrix(runif(2500),nr=500)
x[1:200,] <- t(t(x[1:200,])<G1)*1
x[201:500,] <- t(t(x[201:500,])<G2)*1
colnames(x)=paste("Category",1:5,sep="")

write.csv(x,file="lcadata.csv",row.names=FALSE)
