###########################
# 12.2 Wbgf̐
###########################

library(mlogit)
data(Yogurt)
head(Yogurt,15)

id<-Yogurt$id
np<-length(id)

# eƌv̍Ō̍w_肵ăf[^𕪊
last<-rep(0,np)
last[np]<-1
for(i in 1:(np-1)){
	if (id[i]!=id[i+1]) last[i]<-1
}

Yogurt1<-subset(Yogurt,last==0) # CETvEf[^
Yogurt2<-subset(Yogurt,last==1) # z[hAEgETvEf[^

# f[^`̕ϊ
Yogdata1 <- mlogit.data(Yogurt1, choice = "choice", shape = "wide", varying = c(2:9), sep=".")
Yogdata2 <- mlogit.data(Yogurt2, choice = "choice", shape = "wide", varying = c(2:9), sep=".")

# Wbgf̐
Yog1 <- mlogit(choice ~ feat+price , data = Yogdata1, reflevel="hiland")
summary(Yog1)


#Iuh\I߂
phat1 <- Yog1$probabilities
head(phat1)

Y1hat <- max.col(phat1)
head(Y1hat)
Yname <- colnames(phat1)
Y1hatname <- Yname[Y1hat]
head(Y1hatname)

mean(Y1hatname==Yogurt1$choice)


# z[hAEgETvf[^Iuh\I߂
phat2 <- predict(Yog1,newdata=Yogdata2)
head(phat2)

Y2hat <- max.col(phat2)
head(Y2hat)
Yname <- colnames(phat2)
Y2hatname <- Yname[Y2hat]
head(Y2hatname)

mean(Y2hatname==Yogurt2$choice)


#######################
# 12.3 ʃf[^̕
#######################

library(mlogit)
library(conjoint)
set.seed(123)

TBattr <- list(StorageSize=c("e32GB","e16GB"),
               BatteryLife=c("12","8"),
               Weight=c("350g","450g"))

experiment <- expand.grid(TBattr)

## zɂṽfUC
TBdesign=caFactorialDesign(data=experiment, type="orthogonal")
TBdesign

#vt@C̃R[h
TBprof <- caEncodedDesign(TBdesign)
TBprof

At <- (-TBprof+1.5)*2

#lʂ̑ID(ACeʂ̏)
TBrank=as.data.frame(matrix(0,12,4))
TBrank[1,] <- c(1,4,3,2)
TBrank[2,] <- c(1,2,3,4)
TBrank[3,] <- c(1,2,4,3)
TBrank[4,] <- c(1,2,4,3)
TBrank[5,] <- c(1,3,4,2)
TBrank[6,] <- c(1,2,4,3)
TBrank[7,] <- c(1,4,2,3)
TBrank[8,] <- c(1,3,4,2)
TBrank[9,] <- c(1,4,3,2)
TBrank[10,] <- c(1,4,2,3)
TBrank[11,] <- c(3,1,4,2)
TBrank[12,] <- c(1,3,4,2)
colnames(TBrank) <- c("ch.item1","ch.item2","ch.item3","ch.item4")

vname <- c("StorageSize", "BatteryLife", "Weight")
iname <- c("item1","item2","item3","item4")

Att <- NULL
viname <- NULL
for(i in 1:3){
        for(j in 1:4){
                 viname <- c(viname,paste(vname[i],iname[j],sep="."))
                 Att <- c(Att,At[j,i])
        }
}

ATT <- matrix(Att,12,12,byrow=TRUE)
colnames(ATT) <- viname

viname
TB <- cbind(TBrank,ATT)
head(TB,4)

res <- mlogit(ch~ StorageSize+BatteryLife+Weight|+0, data=TB, varying=1:16, choice='ch',ranked=TRUE, shape="wide")
summary(res)
predict(res)


################################################################
# 12.4 Is҂𕪗ނi݃NXEWbgf)
################################################################

library(flexmix)
library(mlogit)
data(Catsup)
Catsup = subset(Catsup, id %in% 1:100)
Catsup$experiment = seq_len(nrow(Catsup))
names(Catsup)

Catsdata <- mlogit.data(Catsup, choice = "choice", shape = "wide", varying = c(2:13), sep=".")
Cats1 <- mlogit(choice ~ disp+feat+price , data = Catsdata)
summary(Cats1)

set.seed(123)
res1 <- flexmix(choice ~ disp + feat + price + alt | id, model = FLXMRcondlogit(strata = ~ experiment), data = Catsdata, k = 1)

set.seed(123)
res2 <- flexmix(choice ~ disp + feat + price + alt | id, model = FLXMRcondlogit(strata = ~ experiment), data = Catsdata, k = 2)

set.seed(123)
res3 <- flexmix(choice ~ disp + feat + price + alt | id, model = FLXMRcondlogit(strata = ~ experiment), data = Catsdata, k = 3)

set.seed(123)
res4 <- flexmix(choice ~ disp + feat + price + alt | id, model = FLXMRcondlogit(strata = ~ experiment), data = Catsdata, k = 4)

c(BIC(res1),BIC(res2),BIC(res3),BIC(res4))

summary(res3)
parameters(res3)
parameters(res1)

id1<-Catsdata$id
seg1<-cbind(id1,posterior(res3))

head(seg1,20)

seg<-unique(seg1)
head(seg,20)
apply(seg[,2:4],2,mean)

