#####################
# 13.2 mFIq
#####################

library(lavaan)
fdata=read.csv("factor_data.csv", header=TRUE) 
colnames(fdata)=c("id", "brand", "x1","x2","x3","x4","x5","x6","x7","x8","x9","x10","x11", "pref")

library(psych)
V1s=subset(fdata,select=c(x2,x8,x9,x10))
V2s=subset(fdata,select=c(x3,x6,x7,x11))

# NobNaplha
aV1s=alpha(V1s)
aV2s=alpha(V2s)

summary(aV1s)
summary(aV2s)

# mFIq

model1='f1=~ x2 + x8 + x9 +x10
	f2=~ x3 + x6 + x7 + x11'

fit=cfa(model=model1, data=fdata)
summary(object=fit)

# pX}̕`
library(semPlot)
semPaths(object=fit,whatLabels="stand",style="lisrel",optimizeLatRes=TRUE)


###################################
# 13.3 \fO̎s
####################################
library(lavaan)

d <- read.csv("WOMdat.csv",header=TRUE, comment.char="#")
WOMdata=as.matrix(d[,-1])
row.names(WOMdata)=d[,1]

model2 <- 'f1 =~ x1 + x2 + x3
               f2 =~ x4 + x5 + x6
               f3 =~ x7 + x8
               f4 =~ x9 + x10
               f5 =~ x11 + x12
               f3~ f1 + f2
               f4~ f1 + f2
               f5~ f1 + f2 + f3 + f4
               f1~~f2'

# p[^̐
fit=sem(model=model2,sample.cov=WOMdata, sample.nobs=161, orthogonal=TRUE)
summary(object=fit,fit.measure=TRUE)
parameterEstimates(object=fit)
standardizedSolution(object=fit)

fitMeasures(fit)
fitMeasures(fit, fit.measures=c("rmsea","gfi","agfi"))

# pX}̕`
library(semPlot)
semPaths(object=fit, whatLabels="stand", style="lisrel", optimizeLatRes=TRUE,reorder=FALSE, manifests=c("x1","x2","x3","x4","x5","x6","x7","x8","x11","x12","x9","x10"),latents=c("f1","f2","f3","f5","f4"))

