####################
# 8.1 ւƉA
####################

# ֌W
Rdata=read.csv("regression_data.csv" , header=TRUE, comment.char="#")
attach(Rdata)
head(Rdata,15)

library(maptools)
plot(TaJan, sake, xlab="1̕ϋC",ylab="̏ml")
pointLabel(TaJan,sake,labels=city,cex=0.7)

mean(sake)
Rdata[23,]

cor(TaJan,sake)
cor.test(TaJan,sake)

# A
res=lm(sake~TaJan)
summary(res)

res.coef=coef(res)
res.coef

plot(TaJan, sake, xlab="1̕ϋC",ylab="̏ml")
abline(res$coef[1],res$coef[2])

psake<-predict(res)
plot(sake,psake,asp=1,xlab="ʂ̊ϑl", ylab="ʂ̗\l")
abline(0,1)


####################
# 8.3 㔽f
####################

library(bayesm)
data(tuna)
LMOVE2=log(tuna$MOVE2)
LPRICE2=tuna$LPRICE2
NSALE2=tuna$NSALE2

plot(LPRICE2[NSALE2==0],LMOVE2[NSALE2==0],pch=1)
points(LPRICE2[NSALE2>0],LMOVE2[NSALE2>0],pch=4)
legend("topright",legend=c("normal sale","display"),pch=c(1,4))

res2<-lm(LMOVE2~LPRICE2+NSALE2)
summary(res2)
res2.coef=coef(res2)
res2.coef

plot(LPRICE2[NSALE2==0],LMOVE2[NSALE2==0],pch=1,xlab="log of price", ylab="log of volume")
points(LPRICE2[NSALE2>0],LMOVE2[NSALE2>0],pch=4)
abline(a=res2.coef[1], b=res2.coef[2] ,col="blue", lwd=2)
legend("topright",legend=c("no display","display"),pch=c(1,4))


################################
# 8.4 ̃NXZNV
################################

# uh2ƃuh4
LMOVE2<-log(tuna$MOVE2)
LPRICE2<-tuna$LPRICE2
NSALE2<-tuna$NSALE2

LMOVE4<-log(tuna$MOVE4)
LPRICE4<-tuna$LPRICE4
NSALE4<-tuna$NSALE4


T<-length(LMOVE2)
zeros<-rep(0,T)
ones<-rep(1,T)


Y<-c(LMOVE2,LMOVE4)

Xa0<-c(ones,zeros)
Xb0<-c(zeros,ones)

Xa1<-c(LPRICE2,zeros)
Xb1<-c(zeros,LPRICE4)
Xab1<-c(LPRICE4,LPRICE2)

Xa2<-c(NSALE2,zeros)
Xb2<-c(zeros,NSALE4)
Xab2<-c(NSALE4,NSALE2)

X<-cbind(Xa0,Xb0,Xa1,Xb1,Xab1,Xa2,Xb2,Xab2)

M24<-lm(Y~ X-1)
summary(M24)

# uh1`7
LMOVE<-log(tuna[,2:8])
LPRICE<-as.matrix(tuna[,16:22])
T<-nrow(LMOVE)

ones<-rep(1,T)
ones.exp<-kronecker(diag(7),ones)
LP.exp<-kronecker(diag(7),LPRICE)
X<-cbind(ones.exp, LP.exp)
LMS<-stack(LMOVE)

res<-lm(LMS$values~ X-1)
summary(res)

CPE<-coef(res)[8:56]
CPEM<-matrix(CPE,7,7,byrow=TRUE)
bname<-paste("brand",1:7,sep="")
colnames(CPEM)<-bname
rownames(CPEM)<-bname
CPEM
print(CPEM, digit=3)


######################
# 8.5 sVFAf
######################

# VFAf̐
LMOVE<-log(tuna[,2:8])
LPRICE<-tuna[,16:22]
T<-nrow(LMOVE)

LMOVE.mean<-apply(LMOVE,1,mean)
Y<-LMOVE[,1:6]-kronecker(LMOVE.mean,matrix(rep(1,6),1,6))

LP.mean<-apply(LPRICE,1,mean)
LPS<-LPRICE[,1:6]-kronecker(LP.mean,matrix(rep(1,6),1,6))

YS<-stack(Y)
LPSS<-stack(LPS)

ones.exp<-kronecker(diag(6),rep(1,T))
XS<-cbind(ones.exp,LPSS$values)

res<-lm(YS$values~ XS-1)
summary(res)

MOVE<-tuna[,2:8]
M.sum<-apply(MOVE,1,sum)
SH<-MOVE/(matrix(M.sum,T,7,byrow=FALSE))

opar<-par(no.readonly=TRUE)
par(cex.axis=0.8)
layout(matrix(c(1,2),2,1,byrow=TRUE))
boxplot(SH,main="share")
boxplot(LPRICE,main="log of price")
par(opar)

# VFA̗\
betas<-coef(res)
beta0s<-c(betas[1:6],-sum(betas[1:6]))
beta1<-betas[7]

LP.med<-apply(LPRICE,2,median)
a<-exp(beta0s+LP.med*beta1)
suma<-sum(a)
S.hat<-a/suma

bname<-paste("bradn",1:7,sep="")
names(S.hat)<-bname

S.hat

Sfun<-function(LP){
     a=exp(beta0s+LP*beta1)
     suma=sum(a)
     S.hat=a/suma
     return(S.hat)
}

S.hat<-t(apply(LPRICE,1,Sfun))
bname<-paste("MOVE",1:7,sep="")
colnames(S.hat)<-bname

apply(SH,2,mean)
apply(S.hat,2,mean)

opar<-par(no.readonly = TRUE) 
op<-par(pty = "s")
plot(stack(SH)$values,as.vector(S.hat),xlim=c(0,1),ylim=c(0,1),xlab="ϑVFA",ylab="\VFA")
abline(a=0,b=1)
par(opar)

